//# sourceURL=bridge_in.js

window.SDKDelegate = {
  initAd: function(contextId, type, payload) {
    NativeMediation.initAd(contextId, type, payload);
  },
  startAd: function(contextId) {
    NativeMediation.startAd(contextId);
  },
  pauseAd: function(contextId) {
    NativeMediation.pauseAd(contextId);
  },
  resumeAd: function(contextId) {
    NativeMediation.resumeAd(contextId);
  },
  stopAd: function(contextId) {
    NativeMediation.stopAd(contextId);
  },
  setAdVolume: function(contextId, payload) {
    NativeMediation.setAdVolume(contextId, JSON.stringify(payload));
  },
  getAdVolume: function(contextId) {
    return NativeMediation.getAdVolume(contextId);
  },
  getAdSkippableState: function(contextId) {
    return NativeMediation.getAdSkippableState(contextId);
  },
  getAdWidth: function(contextId) {
    return NativeMediation.getAdWidth(contextId);
  },
  getAdHeight: function(contextId) {
    return NativeMediation.getAdHeight(contextId);
  },
  getAdRemainingTime: function(contextId) {
    return NativeMediation.getAdRemainingTime(contextId);
  },
  getDuration: function(contextId) {
    return NativeMediation.getDuration(contextId);
  }
};

window.sdkCtx = 1;
var eventCallbacks = {};
window.eventDispatcher = {
  addListener: function(context, callback) {
    eventCallbacks[context] = callback;
  },
  removeListener: function(context) {
    if(eventCallbacks[context])
      delete eventCallbacks[context];
  },
  dispatch: function(context, event, data) {
    if(eventCallbacks[context])
      eventCallbacks[context](event, data);
  }
};

(function (window) {
  function sdkDebugApi() {
    var s = this;
    s.debug = false;
    s.queue = [];

    s.setDebug = function(debug) {
      s.debug = debug;
    }
    s.pushMessage = function(name, value) {
      if (!s.debug) {
        return;
      }
      s.queue.push([name, value]); // push pair
    }
    s.commitMessages = function() {
      if (!s.debug) {
        return;
      }
      var pushed = false;
      while(s.queue.length > 0){
        var pair = s.queue.shift();
        MobileCallback.onDebugItem(pair[0], pair[1]);
        pushed = true;
      }
      if (pushed) {
        MobileCallback.onDebugItemsEnded();
      }
    }
    s.acceptImpression = function(imp) {
      if (!s.debug || !imp) return;

      s.pushMessage("asid", imp.asid);
      s.pushMessage("mt", imp.mt);
      var tag = imp.tagInfo;
      if (tag) {
        s.pushMessage("url", unescape(tag.url));
      }
      s.pushMessage("videoUrl", unescape(imp.videoUrl));
      s.commitMessages();
    }
  }

  window.avDebugApi = new sdkDebugApi();
})(window);

(function (window) {

  function sdkApiProto() {
    var t = this;
    t.dummyDiv = document.createElement('div');
    t.dummyDiv.classList.add("avp-hidden"); // to fix blackscreen for content
    t.dummyDiv.style.cssText = 'position:absolute;z-index: 9999;width:1px;height:1px;';
    document.body.appendChild(t.dummyDiv);

    t.getReliableWidth = function() {
      return document.body.clientWidth || window.innerWidth;
    }
    t.getReliableHeight = function() {
      return document.body.clientHeight || window.innerHeight;
    }

    t.setViewability = function(viewability) {
      if (player && player.setViewability) {
        player.setViewability(viewability);
      }
    }

    t.unmute = function() {
      if (player) {
        player.unmute();
      }
    }
    t.mute = function() {
      if (player) {
        player.mute()
      }
    }
    t.setVolume = function(level) {
      if (player) {
        player.setVolume(level);
      }
    }
    t.isMuted = function() {
      if (player) {
        return player.getVolume() == 0;
      }
      return false;
    }
    t.getVolume = function() {
      if (player) {
        return player.getVolume();
      }
      return 0;
    }
    t.pause = function() {
      if (player) {
        player.pause();
      }
    }
    t.resume = function() {
      if (player) {
        player.play();
      }
    }
    t.close = function() {
      if (player) {
        player.close();
        MobileCallback.onClose(); // cant trust the callback, need to handle this ourselves
      }
    }
    t.nextContent = function() {
      if (player) {
        player.nextContent();
      }
    }
    t.prevContent = function() {
      if (player) {
        player.prevContent();
      }
    }
    t.setSize = function(width, height) {
      if (player) {
        console.log("setSize " + width +"x" + height);
        player.setSize(width, height);
      } else {
        console.log("setSize " + width +"x" + height + " (no player)");
      }
    }
    t.startAd = function() {
      if (player) {
        player.startAd();
      }
    }
    t.skipAd = function() {
      if (player) {
        player.skipAd();
      }
    }
    t.getReadyAds = function() {
      if (player && player.getReadyAds) {
        return JSON.stringify(player.getReadyAds());
      }
      return "0";
    }
    t.pauseWaterfall = function() {
      if (player) {
        player.pauseWaterfall();
      }
    }
    t.resumeWaterfall = function() {
      if (player) {
        player.resumeWaterfall();
      }
    }
    t.resize = function() {
      if (player) {
        player.setSize(t.getReliableWidth(), t.getReliableHeight());
      }
    }
    t.setSize = function(width, height) {
      if (player) {
        player.setSize(width, height);
      }
    }
    t.setContentByIndex = function(index) {
        if (player) {
            player.setContentByIndex(index);
        }
    }
    t.hidePlaylist = function() {
        if (player) {
            player.hidePlaylist();
        }
    }
    t.changeGui = function(showSkip, showSound, showPlay, showFullscreen) {
        if (player) {
            player.changeGUI({"showFullScreen": showFullscreen}, {"skip": showSkip, "sound": showSound, "playPause": showPlay, "fullscreen": showFullscreen});
        }
    }
    t.setFullscreenState = function(isFullscreen) {
        if (player) {
            player.setFullscreenState(isFullscreen);
        }
    }
    t.addXSec = function() {
        if (player) {
            player.addXSec();
        }
    }
    t.reduceXSec = function() {
        if (player) {
            player.reduceXSec();
        }
    }
    t.setMoveXSec = function(enable) {
        if (player) {
            player.setMoveXSec(enable);
        }
    }
    t.updateContentList = function(contents) {
        if (player) {
            player.updateContentList(JSON.parse(contents));
        }
    }
    t.addContentAt = function(contents, index) {
        if (player) {
            player.addContentAt(JSON.parse(contents), index);
        }
    }
    t.removeContentAt = function(index) {
        if (player) {
            player.removeContentAt(index);
        }
    }

    window.addEventListener("click", function(event) {
      MobileCallback.onPlayerClicked();
    });

    var scriptId = window.sdkConfig.scriptId;
    window.aniviewRenderer = {units:{}};
    window.aniviewRenderer.units[scriptId] = {
      preparePlayer: function(p) {
        player = p;

        p.on("FullScreenRequest", function(){
          MobileCallback.onFullScreenRequest(null);
        });

        p.on("ContentFullScreenRequest", function(data){
           console.log("ContentFullScreenRequest: ", JSON.stringify(data));
           var isFullscreen = null;
           if (data !== undefined && data.data !== undefined && data.data.inFullscreen !== undefined) {
             isFullscreen = data.data.inFullscreen;
           }
          MobileCallback.onContentFullScreenRequest(isFullscreen);
        });

        p.on("onError", function(res){
          MobileCallback.onError(JSON.stringify(res));
        });

        p.on("Inventory", function(data){
          MobileCallback.onInventory();
        });

        p.on("AdLoaded", function(){
          MobileCallback.onLoad();
        });

        p.on("AdImpression", function(imp){
          MobileCallback.onPlay(JSON.stringify(imp));
          window.avDebugApi.acceptImpression(imp);
        });

        p.on("onContentPlay", function(){
          MobileCallback.onContentPlay();
        });

        p.on("AdVideoFirstQuartile", function(){
          MobileCallback.onPlay25();
        });

        p.on("AdVideoMidpoint", function(){
          MobileCallback.onPlay50();
        });

        p.on("AdVideoThirdQuartile", function(){
          MobileCallback.onPlay75();
        });

        p.on("AdVideoComplete", function() {
          MobileCallback.onPlay100(null);
        });

        p.on("AdClickThru", function(data){
          MobileCallback.onClickThrough(JSON.stringify(data));
        });

        p.on("AdSkipped", function(){
          MobileCallback.onSkip(null);
        });

        p.on("AdSkippableStateChange", function(){
          MobileCallback.onSkipAvailable();
        });

        p.on("AdClosed", function(){
//          MobileCallback.onClose(); // ignore for ad
        });

        p.on("AdPaused", function(){
          MobileCallback.onAdPaused();
        });

        p.on("AdPlaying", function(){
          MobileCallback.onAdPlaying();
        });

        p.on("ContentPauseClicked", function(){
          MobileCallback.onContentPauseClicked();
        });

        p.on("ContentPlayClicked", function(){
          MobileCallback.onContentPlayClicked();
        });

        p.on("ContentPaused", function(){
          MobileCallback.onContentPaused();
        });

        p.on("ContentPlaying", function(){
          try {
            MobileCallback.onContentPlaying(JSON.stringify(player.getCurrentContent()));
          } catch (ignore) {
            // Only player v8 has the getCurrentContent method. Player v7 will throw an error.
            MobileCallback.onContentPlaying(null);
          }
        });

        p.on("AdVolumeChange", function(){
            MobileCallback.onAdVolumeChanged(player.getVolume());
        });

        p.on("ContentVolumeChange", function(){
          MobileCallback.onContentVolumeChanged(player.getVolume());
        });

        p.on("onMute", function(){
           MobileCallback.onMute();
        });

        p.on("onUnmute", function(){
           MobileCallback.onUnmute(p.getVolume());
        });

        p.on("AdError", function(err){
          if (err && err.errorlimit) {
            MobileCallback.onAdFetchingCompleted();
          } else {
            MobileCallback.onAdError(JSON.stringify(err));
          }
        });

        p.on("ContentVideoStart", function(){
          MobileCallback.onContentStarted();
        });

        p.on("ContentVideoFirstQuartile", function(){
          MobileCallback.onContentPlay25();
        });

        p.on("ContentVideoMidpoint", function(){
          MobileCallback.onContentPlay50();
        });

        p.on("ContentVideoThirdQuartile", function(){
          MobileCallback.onContentPlay75();
        });

        p.on("ContentVideoComplete", function(){
          MobileCallback.onContentPlay100();
        });

        p.on("ContentTimeChange", function(event, data){
          MobileCallback.onContentTimeChange(data.currentTime, player.getContentDuration());
        });

        p.on("ContentNextClicked", function(){
          MobileCallback.onContentNextClicked();
        });

        p.on("ContentPrevClicked", function(){
          MobileCallback.onContentPrevClicked();
        });

        p.on("WaterfallEnd", function(){
            MobileCallback.onWaterfallEnd();
        });

        p.on("UiVisibilityChange", function(e) {
            MobileCallback.onUiVisibilityChanged(e.data["visibilityState"] == "visible");
        });

        console.log("preparePlayer: finished");
        MobileCallback.onPlayerReady();
      },
      prepareConfig: function(c) {
        c.inappSdk = true;
        console.log("sdkConfig: " +JSON.stringify(window.sdkConfig));

        console.log("expected size set to [" +window.sdkConfig.expectedWidth +"x" +window.sdkConfig.expectedHeight +"]");
        c.width = window.sdkConfig.expectedWidth || t.getReliableWidth();
        c.height = window.sdkConfig.expectedHeight || t.getReliableHeight();
        c.floating = undefined;
        c.adLabel = undefined;
        c.sticky = undefined;
        c.posSelector = "";
        c.aniBoxCSS = "''";
        c.posDfp1x1 = false;
        c.noAdsOnContentPause = true;
        c.mobile.fullScreenMode = "fixed"; // "full" mode does not work properly under native rotate
        c.closeButton = false;
        c.playOnView = false;
        c.pauseOnUnseen = false;
        c.nativeVideo = true;
        c.initialvi = 0;
        c.disableom = false;
        c.poster = { enable: window.sdkConfig.showVideoPoster };
        c.closeFullscreenButton = { enable: window.sdkConfig.showCloseFullscreenButton };

        if (window.sdkConfig.instreamContent) {
            c.content = window.sdkConfig.instreamContent;
        }
        if (window.sdkConfig.disableVideoAds) {
            c.ad = {
                video: { enable: false }
            };
        }

        c.adConfig = c.adConfig || {};
        // c.adConfig.loglevel = 10;
        c.adConfig.tgt = window.sdkConfig.tgt;

        if (c.maxWidth) {
          console.log("removing maxWidth");
          c.maxWidth = undefined;
        }

        if (c.minHeight) {
          console.log("removing minHeight");
          c.minHeight = undefined;
        }

        if(window.sdkConfig.ref1) {
          c.adConfig.ref1 = (c.adConfig.ref1 || "") + "&" + window.sdkConfig.ref1;
        }
        if(window.debug) { window.avDebugApi.setDebug(window.debug); }
      }
    };
  }

  window.avSdkApi = new sdkApiProto();
})(window);